<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Simple AJAX</title>
    <link rel="stylesheet"
          href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-beta.2/css/bootstrap.min.css"
          integrity="sha384-PsH8R72JQ3SOdhVi3uxftmaW6Vc51MKb0q5P2rRUpPvrszuE4W1povHYgTpBfshb"
          crossorigin="anonymous">
</head>
<body>
    <div class="container bg-light p-3">
        <h1 class="text-primary">Simple AJAX</h1>

        <h3 class="text-primary">HTTP GET</h3>
        <div class="row">
            <div class="col-2">
                <label for="id">Product ID</label>
            </div>
            <div class="col-3">
                <input type="number" id="id" name="id" value="5" min="1" max="1000" class="form-control">
            </div>
            <div class="col">
                <button type="button" id="fetch" class="btn btn-primary">
                    Fetch Product
                </button>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <table id="product" class="table table-bordered table-hover table-sm mt-5">
                    <tr>
                        <th>ID</th>
                        <td id="product-id"></td>
                    </tr>
                    <tr>
                        <th>Name</th>
                        <td id="product-name"></td>
                    </tr>
                    <tr>
                        <th>Price</th>
                        <td id="product-price"></td>
                    </tr>
                    <tr>
                        <th>Items</th>
                        <td id="product-items"></td>
                    </tr>
                    <tr>
                        <th>Modified</th>
                        <td id="product-modified"></td>
                    </tr>
                </table>
                <pre id="product-json" class="mt-1">No product shown</pre>
            </div>
        </div>

        <h3 class="text-primary mt-5">Authentication</h3>
        <p>Login with username=nisse and password=hult</p>
        <div class="row">
            <div class="col">
                <h4 class="text-warning">
                    Logged in as <span id="auth-user">nobody</span>
                </h4>
                <form id="loginForm">
                    <table class="table table-bordered table-hover table-sm">
                        <tr>
                            <th>Username</th>
                            <td>
                                <input type="text" id="username" name="username" value="nisse" required/>
                            </td>
                        </tr>
                        <tr>
                            <th>Password</th>
                            <td>
                                <input type="password" id="password" name="password" value="" required/>
                            </td>
                        </tr>
                    </table>
                    <button type="button" id="login" class="btn btn-danger">Login</button>
                    <button type="button" id="logout" class="btn btn-warning">Logout</button>
                </form>
            </div>
        </div>

        <h3 class="text-primary mt-5">HTTP POST</h3>
        <div class="row">
            <div class="col">
                <form id="newProduct">
                    <table class="table table-bordered table-hover table-sm">
                        <tr>
                            <th>Name</th>
                            <td>
                                <input type="text" id="newName" name="name" value="Java Book"/>
                            </td>
                        </tr>
                        <tr>
                            <th>Price</th>
                            <td>
                                <input type="number" id="newPrice" name="price" value="100" min="0" step="0.25"/>
                            </td>
                        </tr>
                        <tr>
                            <th>Items</th>
                            <td>
                                <input type="text" id="newItems" name="items" value="10" min="0"/>
                            </td>
                        </tr>
                    </table>
                    <button type="button" id="create" class="btn btn-success">Create Product</button>
                </form>
            </div>
        </div>

    </div>

    <script
            src="https://code.jquery.com/jquery-3.2.1.min.js"
            integrity="sha256-hwg4gsxgFZhOsEEamdOYGBf13FyQuiTwlAQgxVSNgt4="
            crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.3/umd/popper.min.js"
            integrity="sha384-vFJXuSJphROIrBnz7yo7oB41mKfc8JzQZiCq4NCceLEaO4IHwicKwpJf9c9IpFgh"
            crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-beta.2/js/bootstrap.min.js"
            integrity="sha384-alpBpkh1PFOepccYVYDB4do5UnbKysX5WZXm3XxPqe5iKTfUKjNkCk9SaVuEZflJ"
            crossorigin="anonymous"></script>

    <script type="application/javascript">
        $(() => {
            const baseUri = 'http://localhost:9999';
            $('#product').hide();

            $('#fetch').click(() => {
                $('#product').hide();
                $('#product-json').text('LOADING...');

                const id = $('#id').val();
                console.info('id', id);

                $.get(`${baseUri}/product/${id}`)
                    .then((data) => {
                        console.info('product', data);
                        $('#product-json').text(JSON.stringify(data));

                        $('#product-id').text(data.id);
                        $('#product-name').text(data.name);
                        $('#product-price').text(data.price);
                        $('#product-items').text(data.items);
                        $('#product-modified').text(data.modified);
                        $('#product').show();
                    })
                    .fail((err) => {
                        if (err.status === 401) {
                            $('#product-json').text(`FAILURE: MUST log in`);
                        } else if (err.status === 404) {
                            $('#product-json').text(`FAILURE: ${id} NOT Found`);
                        } else {
                            $('#product-json').text(`FAILURE: ${err.statusText}`);
                        }
                        console.warn('FAILURE', err);
                    })
                ;
            });

            $('#create').click(() => {
                $('#product').hide();
                $('#product-json').text('SUBMITTING...');

                const data = $('#newProduct')
                    .serializeArray()
                    .reduce((data, e) => {
                        data[e.name] = e.value;
                        return data;
                    }, {});
                console.info('new-product', data);

                $.ajax({
                    method: 'POST',
                    url: `${baseUri}/admin/products`,
                    contentType: 'application/json',
                    data: JSON.stringify(data),
                    dataType: 'json',
                    crossDomain: true,
                    headers: {
                        'X-Auth-Token': sessionStorage.getItem('auth.jwt') || ''
                    }
                })
                    .then((data) => {
                        console.info('product', data);
                        $('#product-json').text(JSON.stringify(data));

                        $('#product-id').text(data.id);
                        $('#product-name').text(data.name);
                        $('#product-price').text(data.price);
                        $('#product-items').text(data.items);
                        $('#product-modified').text(data.modified);
                        $('#id').val(data.id);

                        $('#product').show();
                    })
                    .fail((err) => {
                        if (err.status === 401) {
                            $('#product-json').text(`FAILURE: MUST log in`);
                        } else if (err.status === 404) {
                            $('#product-json').text(`FAILURE: ${id} NOT Found`);
                        } else {
                            $('#product-json').text(`FAILURE: ${err.statusText}`);
                        }
                        console.info('FAILURE', err);
                    })
                ;
            });

            $('#login').click(() => {
                const data = $('#loginForm')
                    .serializeArray()
                    .reduce((data, e) => {
                        data[e.name] = e.value;
                        return data;
                    }, {});
                console.info('SENDING login', data);

                $.ajax({
                    method: 'POST',
                    url: `${baseUri}/auth/login`,
                    contentType: 'application/json',
                    data: JSON.stringify(data),
                    dataType: 'json',
                    crossDomain: true,
                })
                    .then((auth) => {
                        console.info('authenticated', auth);
                        $('#auth-user').text(data.username);
                        sessionStorage.setItem('auth.name', auth.username);
                        sessionStorage.setItem('auth.jwt', auth.jwt);
                    })
                    .fail((err) => {
                        if (err.status === 401) {
                            $('#product-json').text(`FAILURE: MUST log in`);
                        } else if (err.status === 404) {
                            $('#product-json').text(`FAILURE: ${id} NOT Found`);
                        } else {
                            $('#product-json').text(`FAILURE: ${err.statusText}`);
                        }
                        console.info('FAILURE', err);
                    })
                ;
            });

            $('#logout').click(() => {
                sessionStorage.removeItem('auth.jwt');
                sessionStorage.removeItem('auth.name');
                $('#auth-user').text('nobody');
            });

        });
    </script>
</body>
</html>